package com.gxzc.zen.api.sys.service.impl

import com.baomidou.mybatisplus.mapper.EntityWrapper
import com.baomidou.mybatisplus.plugins.Page
import com.baomidou.mybatisplus.service.impl.ServiceImpl
import com.gxzc.zen.api.sys.mapper.SysRoleMapper
import com.gxzc.zen.api.sys.model.SysRole
import com.gxzc.zen.api.sys.service.ISysRoleService
import com.gxzc.zen.common.exception.ZenException
import com.gxzc.zen.common.exception.ZenExceptionEnum
import com.gxzc.zen.orm.annotation.ZenTransactional
import org.springframework.stereotype.Service

/**
 * <p>
 * 角色表 服务实现类
 * </p>
 *
 * @author NorthLan123
 * @since 2018-02-06
 */
@Service
class SysRoleServiceImpl : ServiceImpl<SysRoleMapper, SysRole>(), ISysRoleService {

    override fun getListByParam(name: String?, code: String?, enable: Boolean?): MutableList<SysRole> {
        val wrapper = EntityWrapper<SysRole>()
                .eq("name", name)
                .eq("code", code?.toUpperCase())
        if (enable != null) {
            wrapper.eq("enable", enable)
        }
        return baseMapper.selectWOLogic(wrapper)
//        val params: LinkedHashMap<String, Any?> = linkedMapOf(
//                "name" to name,
//                "code" to code?.toUpperCase()
//        )
//        if (enable != null) {
//            params["enable"] = enable
//        }
//        return baseMapper.selectByParams(params)

    }

    override fun getListByParamPage(name: String?, code: String?, enable: Boolean?, current: Int, size: Int): Page<SysRole> {
        val page = Page<SysRole>(current, size)

        val wrapper = EntityWrapper<SysRole>()
                .eq("name", name)
                .eq("code", code?.toUpperCase())
        if (enable != null) {
            wrapper.eq("enable", enable)
        }
        page.records = baseMapper.selectWOLogicPage(page, wrapper)
//        val params: LinkedHashMap<String, Any?> = linkedMapOf(
//                "name" to name,
//                "code" to code?.toUpperCase()
//        )
//        if (enable != null) {
//            params["enable"] = enable
//        }
//        page.records = baseMapper.selectByParamsPage(page, params)
        return page
    }

    @ZenTransactional
    override fun modify(entity: SysRole): SysRole {
//        baseMapper.updateById(entity)
        baseMapper.updateWOLogic(entity, EntityWrapper<SysRole>().eq("id", entity.id))
        return entity
    }

    @ZenTransactional
    override fun physicalDelete(id: Long) {
        if (baseMapper.physicalDeleteById(id) <= 0) {
            throw ZenException(ZenExceptionEnum.BIZ_DELETE_ERROR)
        }
    }
}
