package com.gxzc.zen.common.util

import com.gxzc.zen.common.config.cache.redis.RedisKeyGenerator
import org.springframework.cache.Cache
import org.springframework.cache.CacheManager
import kotlin.reflect.KClass

/**
 * 缓存工具类 适用于 Redis
 * @author NorthLan at 2018/2/8
 */
object RedisCacheUtil {
    private val cacheManager = SpringContextHolder.getBean(CacheManager::class.java)

    fun getCahce(key: String): Cache? {
        return cacheManager.getCache(key)
    }

    fun <T : Any> get(cacheKey: String, key: String, type: KClass<T>): T? {
        return getCahce(cacheKey)?.get(RedisKeyGenerator.joinToString(cacheKey, key), type.java)
    }

    fun get(cacheKey: String, key: String): Cache.ValueWrapper? {
        return getCahce(cacheKey)?.get(RedisKeyGenerator.joinToString(cacheKey, key))
    }

    fun put(cacheKey: String, key: String, value: Any) {
        getCahce(cacheKey)?.put(RedisKeyGenerator.joinToString(cacheKey, key), value)

    }

    fun putIfAbsent(cacheKey: String, key: String, value: Any) {
        getCahce(cacheKey)?.putIfAbsent(RedisKeyGenerator.joinToString(cacheKey, key), value)
    }
}